/***************************************************************************
 * This file is a part of CADS/UVS fits2jpeg conversion software           *
 *   Copyright (C) 2012 by CADS/UV Software Team,                          *
 *                         Indian Institute of Astrophysics                *
 *                         Bangalore 560034                                *
 *                         cads_AT_iiap.res.in                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/*Header Definitions*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <ctype.h>
#include <math.h>
#include <errno.h>
#include <libgen.h>
#include <dirent.h>
#include <unistd.h>
#include <fitsio2.h>
#include <jpeglib.h>
#include <sys/stat.h>
#include <sys/types.h>

#define PROGRAM "fits2jpeg"
#define r2d (90./atan2(1,0))
#define MAX_TEXT 1024

int my_getopt(int, char * const *, const char *);
int make_dir(char *, mode_t);
int make_tree(char *, mode_t);
void banner(void);
void usage(void);
void signals_handler(int);
void set_signals(void);
void printinfo(const char *);
void printwarn(const char *);
void printerro(const char *);
void read_fits(char *, long *, long *, float **);
void scale_pixels(int, unsigned int, float *, JSAMPLE **);
void resize_image(long *, long *, float, JSAMPLE **);
char *strdup(const char *);
